package denim;

import beast.core.BEASTObject;
import beast.core.Description;
import beast.core.Input;
import beast.core.Loggable;

import java.io.PrintStream;

/*
 * Created by Work on 02/11/2016.
 */

@Description("Statistic for per-locus migration counts.")

public class MigrationCountStatistic extends BEASTObject implements Loggable {

    @SuppressWarnings({"CanBeFinal", "WeakerAccess"})
    public Input<CoalescenceMigrationDistribution> coalMigDistInput =
            new Input<>("coalMigDist",
                    "The CoalescenceMigrationDistribution",
                    Input.Validate.REQUIRED);


    public void initAndValidate() {

    }

    @Override
    public void init(PrintStream out) {
        for (int j = 0; j < coalMigDistInput.get().gTreeWEsInput.get().size(); j++) {
            out.print("MigCount-" + coalMigDistInput.get().getGtreeID(j) + "\t");
        }
    }

    @Override
    public void log(int nSample, PrintStream out) {
        for (int j = 0; j < coalMigDistInput.get().gTreeWEsInput.get().size(); j++) {
            out.print(coalMigDistInput.get().getMigrationCount(j) + "\t");
        }
    }

    @Override
    public void close(PrintStream out) {
        // nothing to do
    }

}
